<template>
  <section class="container pageninth-front">
    <h1 class="pageninth-front-title">
      {{database.title}}
      <q-popup-edit v-if="isAuthAdmin" v-model="database.title" auto-save v-slot="scope">
        <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
      </q-popup-edit>
    </h1>
    <div class="pageninth-front-container">
      <div class="pageninth-front-left">
        <div v-for="(el, i) in database.elem"
             :key="`key-wins-${i}`"
             class="pageninth-front-scanned"
        >
          <div class="pageninth-front-scanned-line"></div>
          <h3 class="pageninth-front-scanned-title">
            <q-icon v-if="isAuthAdmin" @click.native="deleteArticle(i)" name="delete" size="30px" color="red" class="hover:opacity-100 cursor-pointer" />
            {{el.name}}
            <q-popup-edit v-if="isAuthAdmin" v-model="database.elem[i].name" auto-save v-slot="scope">
              <q-input v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
            </q-popup-edit>
          </h3>
          <p class="pageninth-front-scanned-text">
            {{el.additionally}}

            <q-popup-edit v-if="isAuthAdmin" v-model="database.elem[i].additionally" auto-save v-slot="scope">
              <q-input v-model="scope.value" type="textarea" dense autofocus counter @keyup.enter="scope.set" />
            </q-popup-edit>
          </p>
          <div class="pageninth-front-scanned-items-overflow swiper swiper_ninth">
            <div class="pageninth-front-scanned-items pageninth-front-scanned-items-first swiper-wrapper">
              <div
                  v-for="(img, indexImage) in el.images"
                  :key="img"
                  class="swiper-slide relative"
                  data-lightbox="testing"
              >
                <img :src="img" alt="" style="max-width: 180px">
                <q-icon v-if="isAuthAdmin" @click.native="deleteImage(img,i,indexImage)" name="delete" size="30px" color="red" class="absolute top-2 right-2 opacity-50 hover:opacity-100 cursor-pointer" />
              </div>

              <label v-if="isAuthAdmin" class="swiper-slide border-2 border-gray-400 my-2 flex items-center justify-center cursor-pointer opacity-50 hover:opacity-100 rounded" :for="`image-key-${i}`">
                <q-icon name="add" size="50px"/>
              </label>

              <input v-if="isAuthAdmin" v-on:change="addImages($event, i)" hidden type="file" :id="`image-key-${i}`">
            </div>
            <div class="swiper-pagination"></div>
          </div>
        </div>
        <q-btn v-if="isAuthAdmin" @click="addArticle" label="Добавить" flat>
          <q-icon name="add" size="25px"/>
        </q-btn>
      </div>
      <div class="pageninth-front-right">
        <div class="pagesecond-front-main-items-container">
          <div class="pagesecond-front-main-items">		<div class="pagesecond-front-main-item">
            <div class="pagesecond-front-main-item-title">
              <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item1.svg">
              <div class="pagesecond-front-main-item-title-cont-first">
                <h3>Получить бесплатно</h3>
              </div>
            </div>
            <p class="pagesecond-front-main-item-text">решения и постановления судов по делам, аналогичным вашему</p>
          </div>
            <div class="pagesecond-front-main-item">
              <div class="pagesecond-front-main-item-title">
                <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item2.svg">
                <div class="pagesecond-front-main-item-title-cont">
                  <h3>Узнайте шансы</h3>
                </div>
              </div>
              <p class="pagesecond-front-main-item-text">по своему делу на основе постановлений и решений судов</p>
            </div>
            <div class="pagesecond-front-main-item">
              <div class="pagesecond-front-main-item-title">
                <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item3.svg">
                <div class="pagesecond-front-main-item-title-cont">
                  <h3>Бесплатные ходатайства</h3>
                </div>
              </div>
              <p class="pagesecond-front-main-item-text">по возврату прав</p>
            </div>
            <div class="pagesecond-front-main-item">
              <div class="pagesecond-front-main-item-title-fourth">
                <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item4.svg">
                <div class="pagesecond-front-main-item-title-cont">
                  <h3>Получить видеоинструкцию</h3>
                </div>
              </div>
              <p class="pagesecond-front-main-item-text-fourth">по возврату прав</p>
            </div>
            <div class="pagesecond-front-main-item">
              <div class="pagesecond-front-main-item-title-fourth">
                <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item4.svg">
                <div class="pagesecond-front-main-item-title-cont">
                  <h3>Бесплатный интенсив онлайн</h3>
                </div>
              </div>
              <p class="pagesecond-front-main-item-text-fourth">“Как вернуть права”</p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import {computed, onMounted, ref, watch} from 'vue'
import {useStore} from "vuex";
import { getDatabase, ref as firebaseRef, child, get, update } from "firebase/database";
import { getStorage, ref as firebaseStorageRef, getDownloadURL, uploadBytesResumable, deleteObject, listAll } from "firebase/storage";
export default {
  name: "Wins",
  setup () {
    const store = useStore()
    const db = getDatabase();
    const dbRef = firebaseRef(db);
    const storage = getStorage();
    const database = ref({});
    const databaseLoad = ref(true);
    const databaseRouter = ref([]);

    async function getDatabaseFirebase() {
      await get(child(dbRef, '/wins')).then((snapshot) => {
        if (snapshot.exists()) {
          database.value = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });
      await get(child(dbRef, `/router`)).then((snapshot) => {
        if (snapshot.exists()) {
          databaseRouter.value = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });

      databaseLoad.value = false
    }


    async function addImages (event, i) {
      const input = event.target
      const file = input.files[0]

      // Проверяем, является ли файл изображением
      if (file.type.startsWith('image/')) {
        const uploadTask = uploadBytesResumable(firebaseStorageRef(storage, `wins/${file.name}`), file);
        uploadTask.on('state_changed',
            (snapshot) => {
              // Observe state change events such as progress, pause, and resume
              // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
              const progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
              console.log('Upload is ' + progress + '% done');
              switch (snapshot.state) {
                case 'paused':
                  console.log('Upload is paused');
                  break;
                case 'running':
                  console.log('Upload is running');
                  break;
              }
            },
            (error) => {
              // Handle unsuccessful uploads
            },
            () => {
              // Handle successful uploads on complete
              // For instance, get the download URL: https://firebasestorage.googleapis.com/...
              getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
                const arr = database.value.elem[i]
                console.log(i)
                console.log(database.value.elem[i])
                if (arr.images && arr.images.length) arr.images.push(downloadURL)
                else arr.images = [downloadURL]
                console.log('File available at', downloadURL);
              });
            }
        );
      } else {
        return null
      }
    }
    async function deleteImage (desertRef, indexElem, indexImage) {
      database.value.elem[indexElem].images = database.value.elem[indexElem].images.filter(el => el !== desertRef)
      await deleteObject(firebaseStorageRef(storage, desertRef))
    }

    async function addArticle () {
      database.value.elem.push({
        additionally: "Управление транспортным средством водителем, находящимся в состоянии опьянения",
        name: "Статья 12.8.1",
        images: []
      })
    }
    async function deleteArticle (index) {
      database.value.elem.splice(index, 1);
    }

    watch(database, ()=>{
      !databaseLoad.value && update(dbRef, {'/wins': database.value});
    }, { deep: true })
    onMounted(() => {
      getDatabaseFirebase()
    })

    return {
      isAuthAdmin: computed(() => store.getters.isAdmin && store.getters.isAuth),
      database,
      addImages,
      deleteImage,
      addArticle,
      deleteArticle,
    }
  }
}
</script>

<style scoped>
@import "../assets/css/style_pageninth_desktop.css";
@import "../assets/css/style_pageninth_mobile.css";
@import "../assets/css/style_pagesecond_mobile.css";
@import "../assets/css/style_pagesecond_desktop.css";
.pageninth-front-container {
  display: flex;
  flex-direction: inherit;
}
</style>
